<xsd:schema xmlns:xsd="http://www.w3.org/2001/XMLSchema"
  targetNamespace="http://www.cfs++.org/simulation"
  xmlns="http://www.cfs++.org/simulation"
  xmlns:sim="http://www.cfs++.org/simulation"
  elementFormDefault="qualified">
  
  <xsd:annotation>
    <xsd:documentation xml:lang="en">
      Parameter file schema for the Coupled Field Data processing
      project CFS-Dat
    </xsd:documentation>
  </xsd:annotation>
  
  <xsd:include schemaLocation="../../CFS-Simulation/Schemas/CFS_FileFormats.xsd"/>

  <xsd:include schemaLocation="CFSDat_BaseFilter.xsd"/>
  <xsd:include schemaLocation="CFSDat_NearestNeighbour.xsd"/>
  <xsd:include schemaLocation="CFSDat_InterpolationRBF.xsd"/>
  <xsd:include schemaLocation="CFSDat_FEBased.xsd"/>
  <xsd:include schemaLocation="../CFS_Dat.xsd"/>
  <xsd:include schemaLocation="CFSDat_InterpolationType.xsd"/>
  
  
  <!-- ******************************************************************** -->
  <!-- Base data-type for field-interpolation -->
  <!-- ******************************************************************** -->
  <xsd:complexType name="DT_Interpolation">
    <xsd:complexContent mixed="true">
      <xsd:extension base="DT_BaseFilter">
        <xsd:sequence>
          <xsd:element name="IntSchemeNN" type="DT_NNScheme" minOccurs="0"/>
          <xsd:element name="IntSchemeRBF" type="DT_RBFScheme" minOccurs="0"/>
          <xsd:element name="fetype" type="DT_FEInterpolationType" minOccurs="0"/>
          <xsd:element name="useElemAsTarget" type="xsd:boolean" default="0" minOccurs="0">
            <xsd:annotation>
              <xsd:documentation xml:lang="en">
                Parameter that defines the target entity, Nodes(false=default) or Element(true)
              </xsd:documentation>
            </xsd:annotation>
          </xsd:element>
          <xsd:element name="noSlipWall" minOccurs="0">
            <xsd:complexType>
              <xsd:attribute name="name" type="xsd:token" use="required"/>
            </xsd:complexType>
          </xsd:element>
          <xsd:element name="sourceSum" type="xsd:boolean" default="0" minOccurs="0"></xsd:element>
          <xsd:element name="targetMesh">
            <xsd:complexType>
              <xsd:choice>
                <xsd:group ref="sim:InputGroup" minOccurs="1" maxOccurs="1"/>
              </xsd:choice>
            </xsd:complexType>
          </xsd:element>
          <xsd:element name="singleResult">
            <xsd:complexType>
              <xsd:sequence>
                <xsd:element name="inputQuantity">
                  <xsd:complexType>
                    <xsd:attribute name="resultName" type="xsd:token" use="required"/>
                  </xsd:complexType>
                </xsd:element>
                <xsd:element name="outputQuantity">
                  <xsd:complexType>
                    <xsd:attribute name="resultName" type="xsd:token" use="required"/>
                  </xsd:complexType>
                </xsd:element>
              </xsd:sequence>
            </xsd:complexType>
          </xsd:element>
          <xsd:element name="regions" minOccurs="1" maxOccurs="1">
            <xsd:complexType>
              <xsd:sequence>
                <xsd:element name="sourceRegions">
                  <xsd:complexType>
                    <xsd:sequence>
                      <xsd:element name="region" minOccurs="1" maxOccurs="unbounded">
                        <xsd:complexType>
                          <xsd:attribute name="name"/>
                        </xsd:complexType>
                      </xsd:element>
                    </xsd:sequence>
                  </xsd:complexType>
                </xsd:element>
                <xsd:element name="targetRegions">
                  <xsd:complexType>
                    <xsd:sequence>
                      <xsd:element name="region" minOccurs="1" maxOccurs="unbounded">
                        <xsd:complexType>
                          <xsd:attribute name="name"/>
                        </xsd:complexType>
                      </xsd:element>
                    </xsd:sequence>
                  </xsd:complexType>
                </xsd:element>
              </xsd:sequence>
            </xsd:complexType>
          </xsd:element>
        </xsd:sequence>
        <xsd:attribute name="type" use="required" type="DT_InterpolationType"/>
        <xsd:attribute name="inputFilterIds" use="required" type="xsd:token">
          <xsd:annotation>
            <xsd:documentation> Space separated Ids for the input filter. Creates a connection between
              the filter with the given id and the current filter. Will be ignored for input filters.
            </xsd:documentation>
          </xsd:annotation>
        </xsd:attribute>
      </xsd:extension>
    </xsd:complexContent>
  </xsd:complexType>
  
</xsd:schema>
